function trim(str){
  trim_str = str;
  gsub(/^ +/,"",trim_str);
  gsub(/ +$/,"",trim_str);
  gsub(/ {2,}/," ",trim_str);
  return trim_str;
}

function print_file(fn){
  while(r = getline s < fn){
    if(r == -1){
      print "ERROR: " fn " - " ERRNO;
      return -1;
    }
    print s
  }
  return 0;
}

BEGIN{
  lp = "";
}

/^#libpath/{
  s = $0;
  gsub(/^#libpath/,"",s);
  lp = trim(s) "/";
  next;
}

/^#include/{
  s = $0;
  gsub(/^#include/,"",s);
  fn = lp trim(s);
  print_file(fn);
  next;
}

{
  print $0;
}