SELECT
mdl_user.id AS 'US ID',
mdl_user.lastname AS 'US LNM',
mdl_user.firstname AS 'US FNM',
mdl_course.id AS 'CR_ID',
FROM_UNIXTIME(mdl_user_lastaccess.timeaccess) AS 'LAST AC',
mdl_course.fullname AS 'CR FNM',
mdl_course.category AS 'CT ID'
FROM
mdl_role_assignments,
mdl_context,
mdl_user,
mdl_course,
mdl_user_lastaccess
WHERE
(mdl_context.contextlevel=50)
AND
(mdl_role_assignments.roleid = 3)
AND
(mdl_role_assignments.contextid=mdl_context.id)
AND
(mdl_context.instanceid=mdl_course.id)
AND
(mdl_role_assignments.userid = mdl_user.id)
AND
(mdl_user_lastaccess.userid = mdl_user.id)
AND
(mdl_user_lastaccess.courseid = mdl_course.id)
ORDER BY
mdl_user.id, 
mdl_user_lastaccess.timeaccess DESC, 
mdl_course.id